<script setup lang="ts">
import vueDatePicker from '@vuepic/vue-datepicker'
import { ref } from 'vue'

const selectedDate = ref(new Date())
const textInputOptions = ref({
  format: 'yyyy/MM/dd'
})

const format = (date: Date) => {
  const day = date.getDate()
  const month = date.getMonth() + 1
  const year = date.getFullYear()

  const nowDate = new Date().toLocaleString().split(' ')[0]
  const selectDate = date.toLocaleString().split(' ')[0]

  return nowDate === selectDate
    ? `${year}/${month}/${day}（今天）`
    : `${year}/${month}/${day}`
}

const emit = defineEmits<{
  (event: 'update:modelValue', value: Date | null): void
}>()

function emitValue(): void {
  emit('update:modelValue', selectedDate.value)
}
</script>

<template>
  <vue-date-picker
    v-model="selectedDate"
    :enable-time-picker="false"
    :format="format"
    :text-input-options="textInputOptions"
    cancel-text="取消"
    mode-height="200"
    placeholder="年 / 月 / 日"
    position="left"
    select-text="選擇"
    hide-input-icon
    text-input
    @blur="emitValue()"
    @closed="emitValue()"
  >
    <template #clear-icon>
      <div class="icon-calendar"></div>
    </template>
  </vue-date-picker>
</template>

<style lang="scss" scoped></style>
